<template>
  <div>
    <div class="top-nav">
      <router-link class="active" to="/dashboard">Home</router-link>
      <div class="top-nav-right">
        <router-link to="/account">Account</router-link>
        <router-link to="/logout">Logout</router-link>
      </div>
    </div>
    <div class="card">
      <h6 style="font-weight: bold"> NOTE: The healthcheck code will be considered valid as long as
        an exception is not thrown in the response. The user must add the corresponding exceptions
        in the code. If you select the backoff checkbox, the healthcheck will be retried 3 times
        before posting an incident.</h6>
      <b-container fluid>
          <b-row class="my-1">
            <b-col sm="2">
              <label>Component:</label>
            </b-col>
            <b-col sm="10">
              <div>
                <b-form-select v-model="form.service" required class="mb-3">
                  <!-- This slot appears above the options from 'options' prop -->
                  <template #first>
                    <b-form-select-option :value="null" disabled>-- Please select a component --
                    </b-form-select-option>
                  </template>
                  <!-- These options will appear after the ones from 'options' prop -->
                  <b-form-select-option value="website">WEBSITE</b-form-select-option>
                  <b-form-select-option value="app">APP</b-form-select-option>
                </b-form-select>
                <!-- <div class="mt-3">Selected: <strong>{{ selected }}</strong></div> -->
              </div>
            </b-col>
          </b-row>
          <b-row class="my-1">
            <b-col sm="2">
              <label>Healthcheck name:</label>
            </b-col>
            <b-col sm="10">
              <b-form-input id="name" placeholder="Enter the name of the complex healtcheck"
                            v-model="form.name" required></b-form-input>
            </b-col>
          </b-row>
          <br>
          <b-row>
            <b-col sm="2">
              <label for="textarea-auto-height">Content:</label>
            </b-col>
            <b-col sm="10">
              <b-form-textarea
                id="textarea-auto-height"
                placeholder="Enter the code of the complex healthcheck"
                rows="6"
                max-rows="9"
                v-model="form.content" required
              ></b-form-textarea>
            </b-col>
          </b-row>
          <br>
          <b-row class="my-1">
            <b-col sm="2">
              <label>Incident name:</label>
            </b-col>
            <b-col sm="10">
              <b-form-input id="incident" placeholder=
                "Enter the name of the incident that is generated with this healthcheck"
                            v-model="form.incident" required></b-form-input>
            </b-col>
          </b-row>
          <br>
          <div class="custom-checkbox">
            <b-form-checkbox id="checkbox-1" v-model="form.retries">Backoff</b-form-checkbox>
          </div>

          <div class="float-right">
            <button class="btn btn-primary" v-on:click="onSave" :disabled='isDisabled'>Save</button>
            <button class="btn btn-primary" v-on:click="onTest">Test</button>
          </div>
      </b-container>
    </div>
    <alert :message=message v-if="showMessage" class="red--text"></alert>
    <alertSuccess :message=messageS v-if="showMessageS" class="green--text"></alertSuccess>
  </div>
</template>

<script>
import axios from 'axios';
import Alert from './Alert.vue';
import AlertSuccess from './AlertSuccess.vue';

export const SERVER_API_URL = process.env.SERVER_API_URL || '';

// { "code":"import requests\nr = requests.post('http://127.0.0.1:5000/v1.0/authenticate',
// json = {'username' : 'admin','password' : 'admin'})\ntoken = 'Bearer ' + r.json()['id_token']\n
// requests.get('http://127.0.0.1:5000/v1.0/', headers={'Authorization' : token})" }

export default {
  name: 'ComplexHealthcheck',
  data() {
    return {
      form: {
        service: '',
        component: '',
        name: '',
        content: '',
        retries: false,
        active: true,
      },
      message: '',
      showMessage: false,
      messageS: '',
      showMessageS: false,
    };
  },
  computed: {
    isDisabled() {
      return !this.showMessageS;
    },
  },
  components: {
    alert: Alert,
    alertSuccess: AlertSuccess,
  },
  methods: {
    getComponentID(payload) {
      const path = `${SERVER_API_URL}/v1.0/inStatus`;
      const json = JSON.stringify(payload);
      axios.post(path, json)
        .then((res) => {
          if (res.status === 200) {
            this.form.component = res.data;
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    complexHealthcheck(payload) {
      const path = `${SERVER_API_URL}/v1.0/complex`;
      const json = JSON.stringify(payload);
      axios.post(path, json)
        .then((res) => {
          if (res.status === 200) {
            console.log(res.data);
            this.showMessage = false;
            this.messageS = 'The complex healthcheck has worked! No exception was thrown during healthcheck.';
            this.showMessageS = true;
          }
        })
        .catch((error) => {
          console.error(error);
          this.showMessageS = false;
          this.message = 'The complex healthcheck has not worked! The response has thrown an exception.';
          this.showMessage = true;
        });
    },
    save_complexHealthcheck(payload) {
      const path = `${SERVER_API_URL}/v1.0/complex/save`;
      const json = JSON.stringify(payload);
      axios.post(path, json)
        .then((res) => {
          if (res.status === 200) {
            this.showMessage = false;
            this.messageS = 'The complex healthcheck was saved successfully!';
            this.showMessageS = true;
          }
        })
        .catch((error) => {
          console.error(error);
          if (error.response.status !== 200) {
            this.showMessageS = false;
            this.message = 'Unfortunately, the complex healthcheck could not be saved.';
            this.showMessage = true;
          }
        });
    },
    onTest(evt) {
      evt.preventDefault();
      const payload = {
        code: this.form.content,
        retry: this.form.retries,
      };
      this.complexHealthcheck(payload);
      this.getComponentID({ name: this.form.service });
    },
    onSave(evt) {
      evt.preventDefault();
      const payload = {
        component: this.form.component,
        name: this.form.name,
        code: this.form.content,
        incident: this.form.incident,
        retry: this.form.retries,
        active: this.form.active,
      };
      this.save_complexHealthcheck(payload);
    },
  },
};

</script>

<style scoped>

.card {
  text-align: left;
  margin: 50px 260px 0px;
  padding: 20px 40px;
  width: auto;
  height: 670px;
  box-shadow: 0 8px 26px -4px rgba(0,0,0,0.15);
  border-radius: 5px;
  background: var(--grey-light);
}

label {
  margin: 0 10px 6px;
  color: var(--gray-dark);
}

.float-right {
  text-align: right;
  margin-top: 20px;
  margin-bottom: 0px;
}

.btn {
  float: right;
  margin-top: 1.5rem;
  margin-bottom: 1rem;
  margin-right: 1rem;
  text-transform: unset;
}

.custom-checkbox {
  margin-left: 4px;
}

h6 {
  text-align: left;
  margin-left: 25px;
  margin-bottom: 30px;
  margin-top: 10px;
  color: var(--almost-black);
}

div.red--text {
  margin: 20px 260px 0px;
}

div.green--text {
  margin: 20px 260px 0px;
}

</style>
